-------------------------------------------------------------------------------
-- Dumb Knight
--Copyright (C) 2013  Thoughts of Glought

--This program is free software: you can redistribute it and/or modify
--it under the terms of the GNU General Public License as published by
--the Free Software Foundation, either version 3 of the License, or
--(at your option) any later version.
--------------------------------------------------------------------------------
--This program is distributed in the hope that it will be useful,
--but WITHOUT ANY WARRANTY; without even the implied warranty of
--MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--GNU General Public License for more details.
---------------------------------------------------------------------------------
--You should have received a copy of the GNU General Public License
--along with this program.  If not, see <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------------

DBK = LibStub("AceAddon-3.0"):NewAddon("Dumbknight","AceEvent-3.0","AceConsole-3.0","AceTimer-3.0")
local AceDBOptions = LibStub("AceDBOptions-3.0")
local DBK_DeathKights,DBK_Paladins,DBK_Warriors,DBK_Druid,DBK_Monk,DBK_Hunter,DBK_Warlock,DBK_Configs,DBK_Healers

--Defaults
local defaults = {
	global = {
		fancy = true,
		delay =  60,
		petdelay = 30,
		raidwhispers = true,
		deathknight = true,
		paladin = true,
		warrior = true,
		druid = true,
		monk = true,
        hunter = true,
        warlock = true,
		healers = true,
		debug = false,
		instancechatdps = false,
		instancechatpets = false,
        instancechathunter = false,
        hunterwarlockraidwarn = false
	},
	profile = {
		fancy = true,
	}
}

function DBK:OnInitialize()
	DBK:Print("Dumb Knight Enabled")
	DBK.db = LibStub("AceDB-3.0"):New("DumbKnightDB", defaults, true)
	DBK.db:RegisterDefaults(defaults)
	local profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(DBK.db)

end

function DBK:OnEnable()
	DBK:Print("Dumb knight Command: /dbk Runs check and whispers the death knight")
	DBK:RegisterEvent("PLAYER_ENTERING_WORLD", "dbktimerset")
	DBK:RegisterEvent("GROUP_ROSTER_CHANGED", "whisperDps")
    DBK:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","COMBAT_LOG_EVENT_UNFILTERED")
	DBK:RegisterChatCommand("Dbk", "whisperDps",true)
	DBK_DeathKights = DBK:GetModule("DeathKnightsDBK")
	DBK_Paladins = DBK:GetModule("PaladinsDBK")
	DBK_Warriors = DBK:GetModule("WarriorDBK")
	DBK_Druid = DBK:GetModule("DruidDBK")
	DBK_Monk = DBK:GetModule("MonkDBK")
    DBK_Hunter = DBK:GetModule("HunterDBK")
    DBK_Warlock = DBK:GetModule("WarlockDBK")
	DBK_Healers = DBK:GetModule("HealersDBK")
	DBK_Configs = DBK:GetModule("ConfigDBK")
	DBK_DeathKights:Enable()
	DBK_Paladins:Enable()
	DBK_Warriors:Enable()
	DBK_Druid:Enable()
	DBK_Monk:Enable()
    DBK_Hunter:Enable()
    DBK_Warlock:Enable()
	DBK_Healers:Enable()
	DBK_Configs:Enable()
end

function DBK:OnDisable()
	DBK:UnregisterChatCommand("Dbk")
	DBK_DeathKights:Disable()
	DBK_Paladins:Disable()
	DBK_Warriors:Disable()
	DBK_Druid:Disable()
	DBK_Monk:Disable()
    DBK_Hunter:Disable()
    DBK_Warlock:Disable()
	DBK_Healers:Disable()
	DBK_Configs:Disable()
end

function DBK:dbktimer()
	DBK:whisperDps()
end

function DBK:COMBAT_LOG_EVENT_UNFILTERED(...)
   if DBK.db.global.hunter then  
    DBK_Hunter:petCheck(...)
    DBK_Hunter:hunterCheck(...)
   end 
   if DBK.db.global.warlock then
   DBK_Warlock:petCheck(...)
   end
   if DBK.db.global.healers then
   --DBK_Healers:underAttackCheck(...)
   end
end

function DBK:dbktimerset()
	DBK:ScheduleTimer("dbktimer", DBK:GetDelay())	
end

function DBK:whisperDps()
	--Whisper modules
	if DBK.db.global.deathknight then
		DBK_DeathKights:whisperDk()
	end
	if DBK.db.global.paladin then
		DBK_Paladins:whisperPally()
	end
	if DBK.db.global.warrior then
		DBK_Warriors:whisperWarrior()
	end
	if DBK.db.global.druid then
		DBK_Druid:whisperDruid()
	end
	if DBK.db.global.monk then
		DBK_Monk:whisperMonk()
	end
	
end