-------------------------------------------------------------------------------
-- Dumb Knight
--Copyright (C) 2013  Thoughts of Glought

--This program is free software: you can redistribute it and/or modify
--it under the terms of the GNU General Public License as published by
--the Free Software Foundation, either version 3 of the License, or
--(at your option) any later version.
--------------------------------------------------------------------------------
--This program is distributed in the hope that it will be useful,
--but WITHOUT ANY WARRANTY; without even the implied warranty of
--MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--GNU General Public License for more details.
---------------------------------------------------------------------------------
--You should have received a copy of the GNU General Public License
--along with this program.  If not, see <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------------

local DBK = LibStub("AceAddon-3.0"):GetAddon("Dumbknight")
local DBK_Configs = DBK:NewModule("ConfigDBK","AceConsole-3.0")
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog= LibStub("AceConfigDialog-3.0", true)

--Options
DBKoptions = {
	name = "Dumb Knight",
	handler = DBK,
	type = 'group',
	args = {
		dbkmainheader ={
			order = 1,
			name = "Main Settings",
			width = "double",
			type = "header",
		},
		fancy = {
			name = 'Fancy Whispers',
			desc = 'If ON it will send out a random funny message letting the dps player he is in tanking spec.If OFF it will send a generic message instead. Default is ON',
			order = 2,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.fancy
			end,
			set = function(self,value)
				DBK.db.global.fancy = value
			end,
		},
		instancedpschat = {
			name = 'Instance Chat(dps)',
			desc = 'If ON it will send the messages in instance chat instead of whispering(dps).If OFF it will whisper instead. Default is OFF',
			order = 2,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.instancechatdps
			end,
			set = function(self,value)
				DBK.db.global.instancechatdps = value
			end,
		},
		instancepetchat = {
			name = 'Instance Chat(pets)',
			desc = 'If ON it will send the messages in instance chat instead of whispering(pet owners).If OFF it will whisper instead. Default is OFF',
			order = 2,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.instancechatpets
			end,
			set = function(self,value)
				DBK.db.global.instancechatpets = value
			end,
		},
		instancehunterchat = {
			name = 'Instance Chat(hunter)',
			desc = 'If ON it will send the messages in instance chat instead of whispering(the hunter).If OFF it will whisper instead. Default is OFF',
			order = 2,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.instancechathunter
			end,
			set = function(self,value)
				DBK.db.global.instancechathunter = value
			end,
		},
		warnhuntersandwarlocksinraids = {
			name = 'Warn Hunters and Warlocks in Raids. Only works If your one of the tanks in the raid',
			desc = 'If ON it will warn hunters and warlocks in raids If your one of the tanks.If OFF it will just warn hunters and warlocks in dungeons. Default is OFF',
			order = 2,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.hunterwarlockraidwarn
			end,
			set = function(self,value)
				DBK.db.global.hunterwarlockraidwarn = value
			end,
		},
		delay = {
			name = 'Check Delay',
			desc = 'Set how long before checking for DPS Death Knights in Blood spec when entering instance. Default is 60 secs.',
			order = 3,
			width = "double",
			type = 'range',
			min =  20,
			max =  120,
			get = "GetDelay",
			set = "SetDelay",
		},
		raidwhispers = {
			name = 'Raid Whispers',
			desc = 'If ON it will run the check on the whole raid group.If OFF it will just run the check on subgroups. Default is ON',
			order = 4,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.raidwhispers
			end,
			set = function(self,value)
				DBK.db.global.raidwhispers = value
			end,
		},
		dbkclassheader ={
			order = 5,
			name = "Class Settings - Disable Classes that you don't want to check/whispered",
			width = "double",
			type = "header",
		},
		dbkDK = {
			name = 'Death Knight',
			desc = 'If ON it will check and send whispers if it finds a DPS Death Knight in tank spec.If OFF it will ignore Death Knights. Default is ON',
			order = 6,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.deathknight
			end,
			set = function(self,value)
				DBK.db.global.deathknight = value
			end,
		},
		dbkPally = {
			name = 'Paladins',
			desc = 'If ON it will check and send whispers if it finds a DPS Paladin in tank spec.If OFF it will ignore Paladins. Default is ON',
			order = 7,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.paladin
			end,
			set = function(self,value)
				DBK.db.global.paladin = value
			end,
		},
		dbkWarrior = {
			name = 'Warrior',
			desc = 'If ON it will check and send whispers if it finds a DPS Warriors in tank spec.If OFF it will ignore Warriors. Default is ON',
			order = 8,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.warrior
			end,
			set = function(self,value)
				DBK.db.global.warrior = value
			end,
		},
		dbkDruid = {
			name = 'Druid',
			desc = 'If ON it will check and send whispers if it finds a DPS Druid in tank spec.If OFF it will ignore Druids. Default is ON',
			order = 9,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.druid
			end,
			set = function(self,value)
				DBK.db.global.druid = value
			end,
		},
		dbkMonk = {
			name = 'Monk',
			desc = 'If ON it will check and send whispers if it finds a DPS Monk in tank spec.If OFF it will ignore Monks. Default is ON',
			order = 10,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.monk
			end,
			set = function(self,value)
				DBK.db.global.monk = value
			end,
		},dbkHunter = {
			name = 'Hunter',
			desc = 'If ON it will check and send whispers if it finds a Hunter\'s pet using growl.If OFF it will ignore Hunters. Default is ON',
			order = 11,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.hunter
			end,
			set = function(self,value)
				DBK.db.global.hunter = value
			end,
		},dbkWarlock = {
			name = 'Warlock',
			desc = 'If ON it will check and send whispers if it finds a warlock\'s minion with Threatening Presence.If OFF it will ignore Warlocks. Default is ON',
			order = 12,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.warlock
			end,
			set = function(self,value)
				DBK.db.global.warlock = value
			end,
		},dbkHealer = {
			name = 'Healer',
			desc = 'If ON it will check and send in instance chat if your under attack this is for healers in LFD not for raids.If OFF it will not warn your party members when your under attck. Default is ON',
			order = 13,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.healers
			end,
			set = function(self,value)
				DBK.db.global.healers = value
			end,
		},dbkdebugheader ={
			order = 14,
			name = "Debug Settings - Settings mostly to help the dev debug",
			width = "double",
			type = "header",
		},dbkDebug = {
			name = 'Debug',
			desc = 'If ON it will Enable "Not in group(Class)" messages in chat.If OFF it will not output "Not in group(Class)" messages. Default is OFF',
			order = 15,
			width = "double",
			type = 'toggle',
			get = function()
				return DBK.db.global.debug
			end,
			set = function(self,value)
				DBK.db.global.debug = value
			end,
		},

	},
}

function DBK:GetDelay(info)
	return DBK.db.global.delay
end
function DBK:GetPetDelay(info)
	return DBK.db.global.petdelay
end

function DBK:SetDelay(info,value)
	DBK.db.global.delay = value
end

function DBK:SetPetDelay(info,value)
	DBK.db.global.petdelay = value
end
function DBK_Configs:OnInitialize()
	AceConfig:RegisterOptionsTable("DBK", DBKoptions, {"DumbknightSettings", "dbkset"})
	AceConfigDialog:AddToBlizOptions("DBK", "Dumb Knight")
end
